#include <iostream>

int main()
{
    std::ios::sync_with_stdio(false);
    int N, Q;
    std::cin >> N >> Q;
    int A[N+1];
    for(int i=1; i<=N; i++) std::cin >> A[i];
    int L, R, res;
    for(int i=0; i<Q; i++)
    {
        std::cin >> L >> R;
        bool moze=true;
        for(int j=L; j<=R; j++) if(A[j]==0)
        {
            moze=false;
            break;
        }
        if(moze) std::cout << "1";
        else std::cout << "0";
        std::cout << "\n";
    }
    return 0;
}